\environment entorn

\starttext

\startsubject[title={Equacions de segon grau senzilles}]

\startsubsubject[title={Preguntes}]

<%

exercicis = Hash.new

%>

<%# Exercici 1 %>
<%
exercicis[1] = Array.new

for i in (1...3)
  parametres = Hash.new
  parametres['a'] = rand(-10..10)
  parametres['b'] = rand(-10..10)
  parametres['c'] = rand(-10..20)
  if parametres['a'] == 0
    parametres['a'] = 1
  end
  if parametres['b'] == 0
    parametres['b'] = 1
  end
  if parametres['c'] == 0
    parametres['c'] = 1
  end
  
  exercicis[1].push(parametres)
end
%>

\startexercici[reference=exercici-1] Resoleu les equacions:
\startitemize[a]
<% exercicis[1].each do |par| %>
\item
<% if par['b'] > 0 and par['c'] > 0 %>
$<%=par['a']%>x^2 + <%=par['b']%>x + <%=par['c']%> = 0$
<% end %>
<% if par['b'] > 0 and par['c'] < 0 %>
$<%=par['a']%>x^2 + <%=par['b']%>x  <%=par['c']%> = 0$
<% end %>
<% if par['b'] < 0 and par['c'] > 0 %>
$<%=par['a']%>x^2  <%=par['b']%>x + <%=par['c']%> = 0$
<% end %>
<% if par['b'] < 0 and par['c'] < 0 %>
$<%=par['a']%>x^2  <%=par['b']%>x  <%=par['c']%> = 0$
<% end %>
<% end %>
\stopitemize
\stopexercici



<%# Exercici 2 %>
<%
exercicis[2] = Array.new

for i in (1...3)
  parametres = Hash.new
  
  parametres['a'] = rand(-20..20)
  parametres['b'] = rand(1..30)
  parametres['c'] = rand(1..30)
  parametres['d'] = rand(-20..20)

  if parametres['a'] + parametres['b'] == 0
    parametres['a'] = parametres['b'] + 1
  end
  
  exercicis[2].push(parametres)
end
%>


\startexercici[reference=exercici-2] Resoleu les equacions següents:
\startitemize[a]
<% exercicis[2].each do |par| %>
\item $<%=par['a']%>x^2 + <%=par['b']%> - <%=par['c']%>x = <%=par['d']%> -<%=par['b']%>x^2 $
<% end %>
\stopitemize
\stopexercici



<%# Exercici 3 %>
<%
exercicis[3] = Array.new

for i in (1...3)
  parametres = Hash.new
  
  parametres['a'] = rand(-10..10)
  if parametres['a'] == 0
    parametres['a'] = 1
  end  
  parametres['b'] = rand(1..10)
  
  exercicis[3].push(parametres)
end
%>


\startexercici[reference=exercici-3] Resoleu les equacions següents:
\startitemize[a]
<% exercicis[3].each do |par| %>
\item <% if par['a'] < 0 %>
$(x+<%=par['a'].abs %>)^2 = <%=par['b']%>$
<% else %>
$(x-<%=par['a']%>)^2 = <%=par['b']%>$
<% end %>
<% end %>
\stopitemize
\stopexercici

<%# Exercici 4 %>
<%
exercicis[4] = Array.new

for i in (1...3)
  parametres = Hash.new
  
  parametres['a'] = rand(-10..10)
  if parametres['a'] == 0
    parametres['a'] = 1
  end  
  parametres['b'] = rand(1..10)
  parametres['c'] = rand(-10..10)
  if parametres['c'] == 0
    parametres['c'] = 1
  end
  
  exercicis[4].push(parametres)
end
%>


\startexercici[reference=exercici-4] Resoleu les equacions següents:
\startitemize[a]
<% exercicis[4].each do |par| %>
\item <% if par['a'] < 0 %>
$<%=par['c']%>(x+<%=par['a'].abs %>)^2 = <%=par['b']%>$
<% else %>
$<%=par['c']%>(x-<%=par['a']%>)^2 = <%=par['b']%>$
<% end %>
<% end %>
\stopitemize
\stopexercici

<%# Exercici 5 %>
<%
exercicis[5] = Array.new

for i in (1...3)
  parametres = Hash.new
  
  parametres['a'] = rand(-10..10)
  if parametres['a'] == 0
    parametres['a'] = 1
  end  
  parametres['b'] = rand(1..10)
  parametres['c'] = rand(-10..10)
  parametres['d'] = rand(-10..10)
  
  exercicis[5].push(parametres)
end
%>


\startexercici[reference=exercici-5] Resoleu les equacions següents:
\startitemize[a]
<% exercicis[5].each do |par| %>
\item  $<%=par['a']%>(x+<%=par['b']%>)^2 <%= par['c'] > 0 ? '+' : '-' %><%=par['c'].abs %>x = <%=par['d']%>$
<% end %>
\stopitemize
\stopexercici

\stopsubsubject

<%# ----------------------- Solucions ------------------------ %>
\page[yes]
\startsubsubject[title={Solucions}]

\startitemize
\sym{\in[exercici-1]}
\startitemize[a, text]
<% exercicis[1].each do |par| %>
<% 
   disc = par['b'].pow(2) - 4*par['a']*par['c']
%>
<% if disc < 0 %>
\item No té solució
<% else %>
<%
  solucio_1 = Rational(Math.sqrt(disc) - par['b'],2*par['a'])
  solucio_2 = Rational(-Math.sqrt(disc) - par['b'],2*par['a'])
%>
\item $x \simeq <%=solucio_1.to_f.round(2)%>, x \simeq <%=solucio_2.to_f.round(2)%>$
<% end %>
<% end %>
\stopitemize

\sym{\in[exercici-2]}
\startitemize[a, text]
<% exercicis[2].each do |par| %>
<% 
   disc = par['c']*par['c'] - 4*(par['a']+par['b'])*(par['b'] - par['d'])
%>
<% if disc < 0 %>
\item No té solució
<% else %>
<%
  solucio_1 = Rational(Math.sqrt(disc) + par['c'],2*(par['a']+par['b']))
  solucio_2 = Rational(-Math.sqrt(disc) + par['c'],2*(par['a']+par['b']))
%>
\item $x \simeq <%=solucio_1.to_f.round(2)%>, x \simeq <%=solucio_2.to_f.round(2)%>$
<% end %>
<% end %>
\stopitemize

\sym{\in[exercici-3]}
\startitemize[a, text]
<% exercicis[3].each do |par| %>
<% 
   disc = par['b']
%>
<% if disc < 0 %>
\item No té solució
<% else %>
<%
  solucio_1 = Rational(Math.sqrt(disc) + par['a'],1)
  solucio_2 = Rational(-Math.sqrt(disc) + par['a'],1)
%>
\item $x \simeq <%=solucio_1.to_f.round(2)%>, x \simeq <%=solucio_2.to_f.round(2)%>$
<% end %>
<% end %>
\stopitemize


\sym{\in[exercici-4]}
\startitemize[a, text]
<% exercicis[4].each do |par| %>
<% 
   disc = Rational(par['b'], par['c'])
%>
<% if disc < 0 %>
\item No té solució
<% else %>
<%
  solucio_1 = Rational(Math.sqrt(disc) + par['a'],1)
  solucio_2 = Rational(-Math.sqrt(disc) + par['a'],1)
%>
\item $x \simeq <%=solucio_1.to_f.round(2)%>, x \simeq <%=solucio_2.to_f.round(2)%>$
<% end %>
<% end %>
\stopitemize


\sym{\in[exercici-5]}
\startitemize[a, text]
<% exercicis[5].each do |par| %>
<% 
   disc = (2 * par['a']* par['b'] + par['c']).pow(2) - 4*par['a']*(par['a']*par['b'].pow(2) - par['d']) 
%>
<% if disc < 0 %>
\item No té solució
<% else %>
<%
  solucio_1 = Rational(Math.sqrt(disc) - (2*par['a']*par['b'] + par['c']),2*par['a'])
  solucio_2 = Rational(-Math.sqrt(disc) - (2*par['a']*par['b'] + par['c']),2*par['a'])
%>
\item $x \simeq <%=solucio_1.to_f.round(2)%>, x \simeq <%=solucio_2.to_f.round(2)%>$
<% end %>
<% end %>
\stopitemize

\stopitemize

\vfill
Les solucions d'aquests exercicis s'han calculat automàticament usant programari lliure: encara que totes les expressions són correctes, potser algunes es poden simplificar més.

\stopsubsubject

<%# ----------------------- Resolució ------------------------ %>
\page[yes]
\startsubsubject[title={Resolució}]

\startitemize
\sym{\in[exercici-1]}
\startitemize[a]
<% exercicis[1].each do |par| %>
<% a = par['a']
   b = par['b']
   c = par['c']
   disc = b.pow(2) - 4*a*c
%>

\item $<%=a%>x^2 <%= b < 0 ? '-' : '+' %><%= b.abs %>x <%= c < 0 ? '-' : '+' %><%= c.abs %> = 0$ $\Rightarrow$ $(<%=2*a%>x <%= b < 0 ? '-' : '+' %><%= b.abs %>)^2 = <%= b < 0 ? '(' : '' %><%= b %><%= b < 0 ? ')' : '' %>^2 -4\cdot <%= a < 0 ? '(' : '' %><%= a %><%= a < 0 ? ')' : '' %>\cdot <%= c < 0 ? '(' : '' %><%= c %><%= c < 0 ? ')' : '' %>$ $\Rightarrow$ $(<%=2*a%>x <%= b < 0 ? '-' : '+' %><%= b.abs %>)^2 = <%=disc%>$ $\Rightarrow$ <% if disc <0 %> No té solució <% else %>  $<%=2*a%>x <%= b < 0 ? '-' : '+' %><%= b.abs %> = \pm \sqrt{<%=disc%>}$ $\Rightarrow$ $x \simeq <%=Rational(Math.sqrt(disc)-b,2*a).to_f.round(2) %>$,  $x \simeq <%=Rational(-Math.sqrt(disc)-b,2*a).to_f.round(2) %>$<% end %>
<% end %>
\stopitemize

\sym{\in[exercici-2]} \startitemize[a]
<% exercicis[2].each do |par| %>
<% a = par['a']
   b = par['b']
   c = par['c']
   d = par['d']
   disc = c.pow(2) - 4*(a+b)*(b-d)
%>

\item $<%=a%>x^2 + <%=b%> - <%=c%>x = <%=d%> -<%=b%>x^2$ $\Rightarrow$ $<%=a%>x^2 + <%=b%> -<%=c%>x <%=d < 0 ? '+' : '-'%><%=d.abs%> + <%=b%>x^2 = 0$ $\Rightarrow$ $ <%=a+b%>x^2 - <%=c%>x <%=b-d < 0 ? '-' : '+'%><%=(b-d).abs%> = 0$ $\Rightarrow$ $(<%=2*(a+b)%>x - <%=c%>)^2 = <%=disc%>$ $\Rightarrow$ <% if disc <0 %> No té solució <% else %> $<%=2*(a+b)%>x - <%=c%> = \pm\sqrt{<%=disc%>}$ $\Rightarrow$ $x \simeq <%= Rational(c+Math.sqrt(disc).round(3),2*(a+b)).to_f.round(3) %>$, $x \simeq <%= Rational(c-Math.sqrt(disc).round(3),2*(a+b)).to_f.round(3) %>$ <% end %>
<% end %>
\stopitemize

\sym{\in[exercici-3]} \startitemize[a]
<% exercicis[3].each do |par| %>
<% a = par['a']
   b = par['b']
%>

\item $(x<%= a < 0 ? '+' : '-' %><%=par['a'].abs %>)^2 = <%=par['b']%>$ $\Rightarrow$ $x<%= a < 0 ? '+' : '-' %><%=par['a'].abs %> = \pm \sqrt{<%=par['b']%>}$ $\Rightarrow$ <% if b < 0 %>No té solució <% else %> $x = \pm\sqrt{<%=b%>}  <%= a < 0 ? '-' : '+' %><%=par['a'].abs %>$ $\Rightarrow$ $x \simeq <%=Rational(Math.sqrt(b)+a,1).to_f.round(3) %>$, $x \simeq <%=Rational(-Math.sqrt(b)+a,1).to_f.round(3) %>$ <% end %> 
<% end %>
\stopitemize

\sym{\in[exercici-4]} \startitemize[a]
<% exercicis[4].each do |par| %>
<% a = par['a']
   b = par['b']
   c = par['c']
%>

\item $<%=c%>(x<%= a > 0 ? '-' : '+' %><%=a.abs %>)^2 = <%=b%>$ $\Rightarrow$ $(x <%= a > 0 ? '-' : '+' %> <%=a.abs %>)^2 = \frac{<%=b %>}{<%=c %>}$ $\Rightarrow$ <% if c < 0 %> No té solució <% else %> $x = \pm \sqrt{\frac{<%=b %>}{<%=c %>}} <%= a > 0 ? '+' : '-' %><%=a.abs %> $ $\Rightarrow$ $x \simeq <%= (Math.sqrt(Rational(b,c)) + a).round(3)%>$, $x \simeq <%= (-Math.sqrt(Rational(b,c)) + a).round(3)%>$ <% end %>
<% end %>
\stopitemize


\sym{\in[exercici-5]} \startitemize[a]
<% exercicis[5].each do |par| %>
<% a = par['a']
   b = par['b']
   c = par['c']
   d = par['d']
   disc = (2 * a* b + c).pow(2) - 4*a*(a*b.pow(2) - d) 
%>

\item $<%=a%>(x+<%=b%>)^2 <%= c > 0 ? '+' : '-' %> <%=c.abs%>x = <%=d%>$ $\Rightarrow$ $<%=a%>(x^2 + <%=2 * b %> x  + <%=b.pow(2)%>) <%= c > 0 ? '+' : '-' %> <%=c.abs%>x = <%=d%>$ $\Rightarrow$ $<%=a%>x^2  <%= a > 0 ? '+' : '-' %><%=(2 * a* b).abs %> x  <%= a > 0 ? '+' : '-' %> <%=(a*b.pow(2)).abs%> <%= c > 0 ? '+' : '-' %> <%=c.abs%>x = <%=d%>$ $\Rightarrow$ $<%=a%>x^2 <%= 2*a*b +c > 0 ? '+' : '-' %> <%=(2 * a* b + c).abs %> x <%= a*b.pow(2) -d > 0 ? '+' : '-' %> <%= (a*b.pow(2) - d).abs%> = 0$ $\Rightarrow$ $(<%=2*a%>x <%= 2*a*b +c > 0 ? '+' : '-' %> <%=(2 * a* b + c).abs %>)^2 = <%= (2 * a* b + c).pow(2) - 4*a*(a*b.pow(2) - d) %>$ $\Rightarrow$ <% if disc < 0 %> No té solució <% else %> $x \simeq <%= Rational(Math.sqrt(disc) - (2 * a* b + c), 2*a).to_f.round(3) %>$, $x \simeq <%= Rational(-Math.sqrt(disc) - (2 * a* b + c), 2*a).to_f.round(3) %>$ <% end %>

<% end %>
\stopitemize


\stopitemize

\vfill
La resolució d'aquests exercicis s'ha calculat automàticament usant programari lliure: encara que totes les expressions són correctes, potser algunes es poden simplificar més.

\stopsubsubject

\stopsubject

\stoptext
